!- TRIANGULAR μOS 1.36 for Commodore 128
!- UOS


!- Set BASIC variables & launch hardware tests & set memory variables :: set poke808 to 110 for enable and 105 (default) to disable Run/Stop key
0print"{home*2}":graphic.,1:color4,1:color.,1:poke808,105:clr:gosub83:slow:print"{ct k}{cyan}{142}{27}l":poke53269,.:q$=chr$(34):vr=1.36:pa=65532:sleep1:iffre(.)<53200thenn$="not enough ram!":goto20
1gosub18:fm=128:sleep1:gosub8:dd=1:poke3069,fm:poke3060,dd:poke3061,.:poke3066,158:poke3065,31:poke3067,.:poke3068,230:poke3062,1:poke3063,132:poke3064,186:vt=vr*100:poke3050,vt:bs=peek(3000):ifbs<8andbs>11thenbs=8

!- Launch screen
2bi=.:print"{clear}";:fast:print"{down*2}{purple}{cm @*40}";:gosub52:printtab(13)"{cm asterisk}{reverse on}            {reverse off}{sh pound}":gosub53:printtab(15)"{cm asterisk}{reverse on}        {reverse off}{sh pound}":gosub53:printtab(17)"{cm asterisk}{reverse on}    {reverse off}{sh pound}":gosub53:printtab(19)"{cm asterisk}{sh pound}":gosub53
3print"{down}{blue}{space*2}{cm c}{reverse on}{cm d}{cm k}{reverse off}{cm b}{reverse on}{cm k}{reverse off}{cm d}{cm b}{reverse on}{cm k}{reverse off}{cm f}{cm k}{reverse on}{cm b}{reverse off}{cm v}{cm k*3} {reverse on}{cm b}{reverse off}{cm f}{reverse on}{cm d}{reverse off}{cm f}{space*3}{light green}{reverse on}{cm d}{reverse off}{cm k}{reverse on}{cm d}{reverse off}{cm v}{cyan}"vr"{return}{blue}{space*3}{cm k}{reverse on}{cm k}{reverse off}{cm b}{reverse on}{cm k*2}{cm f}{cm k}{reverse off}{cm c}{cm k*6} {reverse on}{cm d}{reverse off}{cm k}{reverse on}{cm d}{reverse off}{cm f} {orange}{cm k*2}{light green}{cm k*2}{reverse on}{cm i}{reverse off}{cm k}{return}{blue}{space*3}{cm v}{cm c*6} {cm v}{cm c}{cm v}{reverse on}{cm i}{reverse off}{cm v}{reverse on}{cm i}{reverse off}{cm v*5} {reverse on}{orange}{cm i}{reverse off}{cm k}{reverse on}{light green}{cm i}{reverse off}{cm v}{reverse on}{cm i}{reverse off}{cm v} {light gray}(c) 2023":slow
4sleep1:ifrn=.then61
5printtab(26)"{down*4}{reverse on}{yellow}f1{reverse off} {green}bios setup";:poke208,.:sleep2
6getk$:ifk$="{f1}"then23

!- Load GUI
7n$="gui":l$=" loading...":print"{purple}";:gosub77:goto78

!- Beep sound
8vol15:sound1,9472,10,.,.,.,.,.:forj=.to150:nextj:return

!- Beep sound x3
9gosub8:gosub8:gosub8:return

!- Disk dirve tests (drive # evaluatian: 8+di)
10open1,8+di,2:close1:ifst<>.then14
11gosub17:ifer$=""then14
12open1,8+di,15:print#1,"m-r";chr$(51);chr$(255):get#1,d$:t1=asc(d$+chr$(.)):close1:vt=.:open5,8+di,5,"uos.cfg,s,r":input#5,vt:close5:gosub17:poke3011+di,1:poke3015+di,t1:bi=1:ifvr=vtthengoto15
13return
14poke3011+di,.:poke3015+di,.:return
15bd=8+di:ifbs=bdthent=1
16return

!- Read disk error channel
17open1,8+di,15:input#1,en$,er$,tr$,sc$:close1:return

!- Commodore 128 type confirmation
18poke208,.:poke842,167:poke843,189:poke208,2:getk$:geta$:k$=k$+a$:ifk$="{cm m}{cm x}"andpeek(pa)=61andpeek(pa+1)=255then21
19n$="can't run this{cm m}{cm x}os version!"

!- Shut down with error message
20l$="shut down...":print"{red}";:gosub77:print"{home}{red}"n$:sleep1:gosub9:goto82

!- Set up initial memory variables & graphic test & screen mode detection
21poke3071,6:restore21:fori=.to5:readj:poke3051+i,j:nexti:print"{clear}{down}{cm p}";:gosub84:ifpeek(((peek(2619))*256)+40)=111thenpoke3070,40:fori=1to8:keyi,chr$(i+132):nexti:return:data19,13,82,85,78,13
22print"{clear}":sleep1:n$="this graphic mode is not supported!":goto20

!- BIOS Setup menu
23print"{clear}";:fast:print"{down}{purple} {cm asterisk}{reverse on}{space*2}{reverse off}{sh pound}{cyan} triangular bios"vr"{return}{space*2}{purple}{cm asterisk}{sh pound}{cyan}{space*2}(c) 2023{down*2}{return}{space*2}{light green}commodore {orange}128{cyan}{space*2}ram:"fm"{left}kb{down}{return}{space*3}#: device:{space*9}boot/work":cs$="none":ifcs=1thencs$="cbm datasette":
24db=dd:wb=wd:bb=bd:print"   {reverse on}{red}1{cyan}{reverse off}: ":gosub69:fori=.to3
25gosub58:print"  "8+i;"{left}:",:ifdi(i)=.thenprint"{left*4}none"
26ifdi(i)=1thenprint"{left*4}cbm "dt$(i)"{return}","{up}{right*13}{reverse on}{yellow}"(i*2)+1"{left*3}f{right*3}{green}"(i*2)+2"{left*3}f{reverse off}{cyan}"
27nexti:print"{down}   boot:     work:{return}{down*2}  {reverse on}{red}t{cyan}{reverse off}ime:{return}{down}  {reverse on}{red}r{cyan}{reverse off}eset clock{return}{down*2}  {reverse on}{red}e{cyan}{reverse off}xit {reverse on}{red}s{cyan}{reverse off}ave {reverse on}{red}b{cyan}{reverse off}asic":gosub54:gosub57:slow:poke208,.
28gosub54:gosub57:getk$:ifk$=""then28
29ifk$="e"thenprint"{clear}":dd=db:wd=wb:bd=bb:goto2
30ifk$="r"thenti$="000000"
31ifk$="1"thengosub71:gosub69
32ifk$="{f1}"theni=.:gosub55
33ifk$="{134}"theni=.:gosub56
34ifk$="{135}"theni=1:gosub55
35ifk$="{136}"theni=1:gosub56
36ifk$="{137}"theni=2:gosub55
37ifk$="{138}"theni=2:gosub56
38ifk$="{139}"theni=3:gosub55
39ifk$="{f8}"theni=3:gosub56
40ifk$="t"thengosub46
41ifk$="s"then44
42ifk$="b"then80
43goto28

!- Save BIOS settings and restart
44open1,bd,15,"r0:uos=uos":close1:gosub68:ifer$="ok"thengosub8:gosub8:goto28
45gosub67:goto79

!- Time change
46gosub81:print"{white} {arrow left} {cyan}type new time":ks$="":kv$="":poke208,.:fori=.to5
47gosub54:gosub57:print"{down}{right*8}{light green}"kv$"{cyan}":getk$:ifk$=""then47
48as=asc(k$):ifas>47andas<58thenks$=ks$+k$:goto50
49goto47

!- Time change display
50kv$=kv$+k$:ifi=1ori=3thenkv$=kv$+":"
51nexti:gosub81::print"                 ":ti$=ks$:poke208,.:return

!- Draw horizontal line 1
52print"{sh asterisk*40}":return

!- Draw horizontal line 2
53print"{cm t*40}":return

!- Time update > setup
54t$=ti$:t1$=left$(t$,2):t2$=mid$(t$,3,2):t3$=right$(t$,2):print"{home}{down*17}{right*8}"t1$":"t2$":"t3$:return

!- Set Boot drive
55ifpeek(3011+i)=1thenbd=8+i:return:elsereturn

!- Set Work drive
56ifpeek(3011+i)=1thenwd=8+i:return:elsereturn

!- Boot & Work disk drive update > setup
57print"{home}{down*14}{right*8}{yellow}"bd"{left} ","{left*2}{green}"wd"{left} {cyan}":return

!- Disk drive database
58di(i)=peek(3011+i):dn=peek(3015+i):dt$(i)="{left*4}unknown":ifdi(i)=.thenreturn
59restore59:forj=.to9:readd9:readd9$:ifdn=d9thendt$(i)=d9$
60nextj:return:data108,"1581",173,"1571",16,"2040",76,"1541-ii",170,"1541",7,"2031",32,"3040",169,"4040",255,"1551",48,"{left*4}sd2iec"

!- Check disk drives
61t=.:fordi=3to.step-1:gosub10:nextdi:ift=1thenbd=bs
62wd=bd:poke3000,bd:poke3001,wd:ifbi=.thenee$="   {reverse on}no disk drive!{reverse off}":goto73
63ifbd=.thenee$="   {reverse on}no system disk!{reverse off}":goto73

!- Load uos.cfg
64rn=1:open8,bd,8,"uos.cfg,s,r":close8:gosub68:poke3062,1:ifer$<>"ok"then73
65open8,bd,8,"uos.cfg,s,r":input#8,v1$,wd$,dd$,gc$,gr$,cg$,tc$,pp$:close8:gosub68:poke3068,val(gr$):poke3067,val(gc$):poke3065,val(cg$):wd=val(wd$):dd=val(dd$):poke3060,dd:ifpeek(963+wd)=.thenwd=bd
66poke3001,wd:poke3066,val(tc$):poke3061,val(pp$):goto5

!- Save uos.cfg
67open1,bd,15,"s0:uos.cfg":close1:open8,bd,8,"uos.cfg,w,s":print#8,vr:print#8,wd:print#8,dd:print#8,peek(3067):print#8,peek(3068):print#8,peek(3065)::print#8,peek(3066):print#8,peek(3061):close8:poke3060,dd:poke3000,bd:poke3001,wd:gosub68:return

!- Read disk error chanell
68open1,bd,15:input#1,en$,er$,tr$,sc$:close1:return

!- Update Datasette status graphic > setup
69ifdd=.thenprint"{home}{down*8}{right*6}none         ":return
70ifdd=1thenprint"{home}{down*8}{right*6}cbm datasette":return:elsereturn

!- Datasette enable On/Off
71ifdd=.thendd=1:return
72ifdd=1thendd=.:return:elsereturn


!- Disk drive error
73printtab(9)"{down*2}{red}"ee$"{return}{down}{yellow} {reverse on}f1{green}{reverse off} retry"tab(31)"{red}{reverse on}f8{green}{reverse off} basic";:poke208,.:gosub9
74getk$:ifk$="{f1}"thenrn=.:print"{up*3}{black}":fori=.to2:print"{space*38}":nexti:print"{delete*2}{up*5}":goto4
75ifk$="{f8}"then80
76goto74

!- Draw load
77 fast:movspr4,.#.:movspr4,160,170:sprite4,1,1,.,1,.,.:print"{clear}{down*15}"tab(17)"{cm asterisk}{reverse on}    {reverse off}{sh pound}{return}"tab(18)"{cm asterisk}{reverse on}  {reverse off}{sh pound}{return}"tab(19)"{cm asterisk}{sh pound}{return}{down}{white}"tab(12)"{cm @*16}{return}{white}"tab(11)"{cm m}{reverse on}{blue}{cm m*9}{reverse off}       {white}{cm g}{return}{white}"tab(12)"{cm t*16}{return}{white}{down}"tab(9)"     "l$:slow:return

!- Load sequence
78print"{home}{black}load "q$n$q$","bd:poke208,.:fori=.to5:g=peek(3051+i):poke842+i,g:nexti:poke208,6:new

!- Restaring
79l$="restarting...":print"{yellow}";:gosub77:n$="uos":goto78

!- Shut down
80l$="shut down...":print"{red}";:gosub77:goto82

!- Clear Time changer
81gosub57:print"{down}{right*8}       ";:return

!- Shut down soft reset
82sleep2:print"{clear}":sys57344

!- Sprites off & sound off
83fori=1to8:spritei,.:nexti:vol.:fori=1to3:soundi,.,.,.,.,.,.,.:nexti:return

!- VIC-II init & sprites space clear & sprites shapes
84fori=3584to4095:pokei,.:nexti:restore85:fori=.to59:readj:poke3776+i,j:nexti:return
85data0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255
